import java.awt.Image;
import java.awt.image.ImageObserver;
import java.awt.image.BufferedImage;

public class BufferedImageFilter2AsImageFilter implements ImageFilter {
	private BufferedImageFilter2 bufImgFilter;
	private BufferedImage inImgBuffer;
	private BufferedImage outImgBuffer;
	
	public BufferedImageFilter2AsImageFilter(BufferedImageFilter2 bufImgFilter) {
		this.bufImgFilter = bufImgFilter;
		this.inImgBuffer = null;
		this.outImgBuffer = null;
	}
	
	public Image createFilteredImage(Image img) {
		int width = img.getWidth(null);
		int height = img.getHeight(null);
		
		// Ensure that the internal BufferedImage is size-compatible
		// with the image to be filtered
		if ((this.inImgBuffer == null) ||
			(this.inImgBuffer.getWidth() != width) ||
			(this.inImgBuffer.getHeight() != height))
		{
			this.inImgBuffer = new BufferedImage(
				width,
				height,
				BufferedImage.TYPE_INT_ARGB);
			this.outImgBuffer = new BufferedImage(
				width,
				height,
				BufferedImage.TYPE_INT_ARGB);
		}
		
		// Copy the data from the original image into the BufferedImage
		inImgBuffer.getGraphics().drawImage(img, 0, 0, (ImageObserver) null);
		
		// Filter the image
		bufImgFilter.filter(inImgBuffer, outImgBuffer);
		
		// Return the filtered image
		return outImgBuffer;
	}
	
	public String toString() {
		return bufImgFilter.toString();
	}
}